//Verwendung
//_app.BDE=new BDE_Min()
//_app.BDE.Init()
//Funktionen
//_app.BDE.DatabaseFound(<cDatenbankalias>)                     Ermittelt, ob der Datenbankalias vorhanden ist
//_app.BDE DatabaseDir(<cDatenbankalias>)                       Ermittelt den Pfad zur angegebenen Datenbank, wenn nicht definiert wird Leerstring zurckgegeben
//_app.BDE.CreateAlias(<cDatenbankname>,<cPfad>,<cTabellentyp>) Setzt den angegebenen Datenbankalias in den Pfad
//                                                              Tabellentyp ist optional, wenn nicht angegeben, wird dBASE verwendet
//_app.BDE.DeleteAlias(<cDatenbankname>)                        Lscht den angegebene Alias
//
class BDE_Min

   FUNCTION Init
   EXTERN CINT GetAliasPath(CHANDLE,CSTRING,CSTRING,CSTRING) IDAPI32 from "DbiFormFullName"
   EXTERN CINT DbiDeleteAlias(CHANDLE,CPTR )                 IDAPI32
   EXTERN CINT DbiAddAlias(CHANDLE,CPTR,CPTR,CPTR,CLOGICAL)  IDAPI32
   EXTERN CINT DbiGetSysConfig(CPTR)                         IDAPI32
   RETURN

   FUNCTION DataBaseFound(cDatabase)
   //Ermittelt, ob die Datenbank vorhanden ist
   LOCAL d
   LOCAL dbArray
   LOCAL lFound
   LOCAL i

   d=new DATABASE()
   dbArray=d.getschema("Databases")
   RELEASE OBJECT d
   lFound=false
   FOR I=1 to dbArray.size
      IF UPPER(cDatabase)==UPPER(dbArray[I])
         lFound=true
         EXIT
      ENDIF
   NEXT
   RETURN lFound

   FUNCTION DatabaseDir
   //Ermittelt das Directory der angegebenen Datenbank
   //Der Datenbankname mu als Parameter bergeben werden, also z.B. _app.BDE.DatabaseDir(<Datenbankname>)
   PARAMETERS cDatabase
   LOCAL oDatabase
   LOCAL cRet

   cRet=NULL
   IF TYPE("cDatabase")=="C" .AND. .NOT. EMPTY(cDatabase)
      IF CLASS::DatabaseFound(cDatabase)
         cRet=SPACE(261)
         oDatabase=new DATABASE()
         oDatabase.databaseName=cDatabase
         oDatabase.active=true
         TRY
            GetAliasPath(oDatabase.handle,"DummyTableName","",cRet)
            cRet=cRet.left(cRet.lefttrim().lastindexof("\"))
         CATCH (exception e)
            cRet=""
         ENDTRY
         oDatabase.active=false
         RELEASE OBJECT oDatabase
      ENDIF
   ENDIF
   RETURN cRet

   FUNCTION DeleteAlias(cAliasName)
   //Lscht den datenbanknamen
   RETURN DbiDeleteAlias(NULL,CLASS::ToUnicode(cAliasName))==0

   FUNCTION CreateAlias(cAliasName,cPath,cTableFormat)
   //Erstellt einen Datenbankalias
   //Falls der Pfad nicht existiert, wird versucht, diesen anzulegen
   IF ARGCOUNT()<3
      cTableFormat="DBASE"
   ENDIF
   CLASS::CheckDirectory(cPath,false)
   RETURN DbiAddAlias(NULL,CLASS::ToUnicode(cAliasName),CLASS::ToUnicode(cTableFormat),CLASS::ToUnicode("PATH:"+cPath),TRUE)==0

   FUNCTION CheckDirectory(cPfad,lSuppressMessage)
   //berprft, ob das Verzeichnis existiert, wenn nicht, wird es angelegt
   LOCAL nTiefe
   LOCAL cOldPfad
   LOCAL lVorhanden

   cOldPfad=SET("DIRECTORY")
   cPfad=TRIM(LTRIM(cPfad))
   cPfad+=IIF(RIGHT(cPfad,1)="\","","\")
   lVorhanden=true
   TRY
      CD (cPfad)
   CATCH (exception e)
      IF LEFT(cPfad,2)=="\\" //UNC-Pfad
         nPos=AT("\",cPfad,4) //Pfad erhlt dann Namen der Arbeitsstation+Freigabe
         nTiefe=4
      ELSE
         nPos  =3
         nTiefe=1
      ENDIF
      DO WHILE nPos>0
         cDirectory=LEFT(cPfad,nPos)
         lVorhanden=CLASS::MakeDirectory(cDirectory)
         IF .NOT. lVorhanden
            IF EMPTY(lSuppressMessage)
               Fehler("Verzeichnis konnte nicht angelegt werden"+CHR(10)+cDirectory)
            ENDIF
            EXIT
         ENDIF
         nTiefe++
         nPos=AT("\",cPfad,nTiefe)
      ENDDO
   ENDTRY
   CD (cOldPfad)
   RETURN lVorhanden

   FUNCTION MakeDirectory
   PARAMETER cDirectory
   LOCAL lAngelegt
   LOCAL cOldDirectory

   cOldDirectory=SET("DIRECTORY")
   lAngelegt=true
   TRY
      CD (cDirectory)
   CATCH (exception e)
      TRY
         MD &cDirectory.
      CATCH (exception e)
         IF " "$cDirectory
            IF LEFT(cDirectory,1)='"'
               cDirectory="'"+cDirectory+"'"
            ELSE
               cDirectory='"'+cDirectory+'"'
            ENDIF
            TRY
               MD &cDirectory.
            CATCH (exception e)
               lAngelegt=false
            ENDTRY
         ELSE
            lAngelegt=false
         ENDIF
      ENDTRY
   ENDTRY
   CD (cOldDirectory)
   RETURN lAngelegt

   FUNCTION FromUnicode(c)
   LOCAL cText
   LOCAL nLen
   LOCAL nInd

   nLen=LEN(c)
   cText=""
   FOR nInd=0 TO nLen-1
      cText+=CHR(c.getByte(nInd))
   NEXT
   RETURN cText

   FUNCTION ToUnicode(c)
   LOCAL cTemp
   LOCAL x

   cTemp=REPLICATE(Chr(0),((LEN(c)+1)/2)+((LEN(c)+1)%2))
   FOR x=1 TO LEN(c)
      cTemp.SetByte(x-1,ASC(SUBSTR(c,x)))
   NEXT
   RETURN cTemp

endclass
