class IAssocArray of AssocArray
	//Full Name:	Indexed Associated Array
	//Description:	Subclass of Associated Array.
   //					GetFirstKey/GetNextKey methods respect sequence in which the keys were added.
   //
   //Version:		1.0
   //Author:		Dan Howard [dBVIPS]
   //Date:			August 2, 2002
   //Source:		dBase.Wishlist newsgroup, thread title 'assocArray'
	//					Code as posted on newsgroup.
   //
   //Version:		2.0
   //Author: 		Jamie A. Grant
   //Date:			September 20, 2004
   //Revision:		Changed NextKey method to GetNextKey.
   //					Allows old FirstKey/NextKey logic to run side-by-side with new GetFirstKey/GetNextKey logic.

	this.aIndex = New Array()

	function AddItem( cKey, xValue )

		if NOT this.isKey(cKey)
			this[cKey] := xValue
			this.aIndex.add( cKey )
		endif

	return

	function GetFirstKey

		if this.aIndex.size > 0
			return this.aIndex[1]
		endif

	return NULL

	function GetNextKey( cKey )
		// Always returns the key after the one supplied in the order
		// that it was added.
		local n
		n = this.aIndex.Scan(cKey)
		if n == 0 or n == this.aIndex.size
			return NULL
		endif

	return this.aIndex[n+1]
endclass