// 

/* 

  Usage:



   Replace
      x = "be"
      oStr = new RegExpString( )
      oStr.String  = "To be, or not to be: That is the question:"  
      oStr.String += "Whether 'tis nobler [better] in the mind to suffer"
      ? oStr.replace( x+"\b/gi", "%"+ x +"%" )  
                                    
   Search
      oStr = new RegExpString( )
      oStr.String  = "To be, or not to be: That is the question:"  
      oStr.String += "Whether 'tis nobler [ better ] in the mind to suffer"
      //  0 based index 
      ? oStr.search( "\bbe/gi", 2 )

   Match
      oStr = new RegExpString( )
      oStr.String = "IS1 is2 IS3 is4"
      x = oStr.match( "is./gi" )
      for i=1 to x.size
         ? x[i]
      next

   Split
      oStr = new RegExpString( )
      oStr.String =  "John,1.Bill,2.Alan,3.Mike"
      x = oStr.split( ",*\d.\b/gi" )
      for i=1 to x.size
         ? x[i]
      next



   Get offsets of mulitple matches
     cRegExp = "\bbe\w*\b/gi"
     oStr = new RegExpString( )
     oStr.String  = "To be, or not to be: That is the question:"  
     oStr.String += "Whether 'tis nobler [better] in the mind to suffer"
     x = oStr.match( cRegExp )
     for i=1 to x.size
        ? x[i]
        ?? "offset: " + oStr.search( cRegExp, i-1 ) at 10
        ?? "length: " + x[i].length at 25
     next

*/



class RegExpString( cString ) of String

   this.re = new OleAutoClient("VBScript.RegExp")

   function match( regExpression )
      //////////////////////////////////////////
      // 
      //  Returns an array containing the matches
      //  found in the string. If no matches
      //  are found, an empty array is returned.
      //
      //////////////////////////////////////////

      local aMatches, m, i
      this.compile( regExpression )
      m = this.re.execute( this.String )
      aMatches = new array()
      if m.count = 0
         return NULL
      endif
      if m.count > 0
         for i=0 to m.count-1
            aMatches.add(m.item(i).value)
         endfor
      endif
      return aMatches


   function replace( regExpression, cNewString )
      //////////////////////////////////////////
      // 
      //  Replaces the matched part of the string
      //  with a new string. If no match is found  
      //  the string remains unmodified 
      //
      //////////////////////////////////////////

      this.compile( regExpression )
      return this.re.replace( this.String, cNewString )

   function search( regExpression, nIndex ) 
      //////////////////////////////////////////
      // 
      //  returns an offset integer for the 
      //  start of the matched text in the   
      //  string. Returns -1 if no match is found.
      //
      //////////////////////////////////////////

      local m, i
      this.compile( regExpression )
      m = this.re.execute( this.String )

      nIndex  = iif(empty(nIndex),0,nIndex)
      if m.count = 0
         i = -1
      else
         if nIndex < m.count
            i = m.item(nIndex).firstindex
         else
            i = -1
         endif
      endif
      return i   


   function split( regExpression )
      //////////////////////////////////////////
      // 
      //  splits a string into fields where the  
      //  regular expression defines the sparator    
      //  returns an array containing the fields. 
      //
      //////////////////////////////////////////
      local m,a,i,nElement
      this.compile( regExpression )
      m = this.re.execute( this.String )
      a = new array()

      if m.item(0).firstindex > 0
         // there is data before the first
         // separator
         a.add( this.substring(0, m.item(0).firstindex ) )
         nElement = 0
      else
         nStart = m.item(0).firstindex + m.item(0).length
         if m.count > 1
            nStop = m.item(1).firstindex
         else
            nStop = this.length
         endif
         a.add( this.substring( nStart, nStop ) )
         nElement = 1                          
      endif
      if m.count > 1
      //  more than one to process
         for i=nElement to m.count-1
            nStart = m.item(i).firstindex + m.item(i).length
            if m.count-1 > i
               nStop = m.item(i+1).firstindex
            else
               nStop = this.length
            endif
            a.add( this.substring( nStart, nStop ) )
         endfor
      endif
      return a
         
   function compile( cRegExp )
      ////////////////////////
      //
      //  For internal use
      //
      /////////////////////////

      local re,cFlag,cPattern
      local bGlobal,bIgnoreCase
      re = new oleAutoClient("VBScript.RegExp")
      re.ingnoreCase = true
      re.pattern = "^(.*)\/([gi][gi]?)$"
      cFlag = re.replace(cRegExp, "$2" )
      cPattern = re.replace( cRegExp, "$1" )

      if not empty( cFlag ) 
         if "g" $ lower(cFlag)
            bGlobal = true
         else
            bGlobal = false
         endif
         if "i" $ lower(cFlag)
            bIgnoreCase  = true
         else
            bIgnoreCase  = false
         endif
      else
         bIgnoreCase  = false
         bGlobal = false
      endif

      this.re.IgnoreCase := bIgnorecase  
      this.re.Global     := bGlobal   
      this.re.pattern    := cPattern 
      return

endclass      





 
