    // Validator Object
class Validator of AssocArray

    // REGEX Elements
    this.re = new OleAutoClient("VBScript.RegExp")
    // matches zip codes
    cPattern =  "\d{5}(-\d{4})?"
    cPicture = "#####-####" 
    this['zipcode'] =  this.createObject(cPattern, cPicture)

    // matches $17.23 or $14,281,545.45 or ...
    cPattern =  "\$\d{1,3}(,\d{3})*\.\d{2}"
    cPicture = "$###,###.##" 
    this['currency'] =  this.createObject(cPattern, cPicture)

    // matches 5:04 or 12:34 but not 75:83
    cPattern =  "^([1-9]|1[0-2]):[0-5]\d$"
    cPicture = "##:##" 
    this['time'] = this.createObject(cPattern, cPicture)

    //matches email
    cPattern =  "^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$"
    cPicture = "account@company.com" 
    this['emailaddress'] = this.createObject(cPattern, cPicture)

    // matches phone ###-###-####
    cPattern =  "^\(?\d{3}\)?\s|-\d{3}-\d{4}$"
    cPicture = "###-###-####" 
    this['phonenumber'] = this.createObject(cPattern, cPicture)

    // International Phone Number
    cPattern =  "^\d(\d|-){7,20}"
    cPicture = "##-###-#####" 
    this['phonenumberinternational'] = this.createObject(cPattern, cPicture)

    // IP Address
    cPattern =  "^((25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.){3}(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])$"
    cPicture = "###.###.###.###" 
    this['ipaddress'] = this.createObject(cPattern, cPicture)

    // Date xx/xx/xxxx
    cPattern =  "^\d{1,2}(\-|\/|\.)\d{1,2}\1\d{4}$"
    cPicture = "##/##/####" 
    this['date'] = this.createObject(cPattern, cPicture)

    // State Abbreviation
    cPattern = "^(AK|AL|AR|AZ|CA|CO|CT|DC|DE|FL|GA|HI|IA|ID|IL|IN|KS|KY|LA|MA|MD|ME|MI|MN|MO|MS|MT|NB|NC|ND|NH|NJ|NM|NV|NY|OH|OK|OR|PA|RI|SC|SD|TN|TX|UT|VA|VT|WA|WI|WV|WY)$"
    cPicture = "##" 
    this['state'] = this.createObject(cPattern, cPicture)

    // Social Security Number
    cPattern =  "^\d{3}\-\d{2}\-\d{4}$"
    cPicture = "###-##-####" 
    this['ssn'] = this.createObject(cPattern, cPicture)

    function validate(cValue, cType)
       c = cType
       ? c.toLowerCase()
       bRet = true
       this.re.pattern = this[ c.toLowerCase() ].pattern
       if not this.re.test( cValue )
          msgbox( cType + ": failure to match " + this[ c.toLowerCase() ].picture ;
                           + " to " + cValue )   
          bRet = false
       endif
       return bRet

    function createObject(cPattern, cPicture)
       local o
       o = new object()
       o.pattern = cPattern 
       o.picture = cPicture 
       return o
endclass
